]> asedeno.scripts.mit.edu Git - git.git/blob - t/test-lib.sh
tests: simplify "missing PREREQ" message
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
82
83 unset GREP_OPTIONS
84
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
93
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
100 # Each test should start with something like this, after copyright notices:
101 #
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
115
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
148
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
174
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
179 }
180
181 say () {
182         say_color info "$*"
183 }
184
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
187
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
193
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197         exec 4>&2 3>&1
198 else
199         exec 4>/dev/null 3>/dev/null
200 fi
201
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
207
208 test_external_has_tap=0
209
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
219 }
220
221 GIT_EXIT_OK=
222 trap 'die' EXIT
223
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
226 #
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
230 #
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
238 }
239
240 test_decode_color () {
241         sed     -e 's/.\[1m/<WHITE>/g' \
242                 -e 's/.\[31m/<RED>/g' \
243                 -e 's/.\[32m/<GREEN>/g' \
244                 -e 's/.\[33m/<YELLOW>/g' \
245                 -e 's/.\[34m/<BLUE>/g' \
246                 -e 's/.\[35m/<MAGENTA>/g' \
247                 -e 's/.\[36m/<CYAN>/g' \
248                 -e 's/.\[m/<RESET>/g'
249 }
250
251 q_to_nul () {
252         perl -pe 'y/Q/\000/'
253 }
254
255 q_to_cr () {
256         tr Q '\015'
257 }
258
259 append_cr () {
260         sed -e 's/$/Q/' | tr Q '\015'
261 }
262
263 remove_cr () {
264         tr '\015' Q | sed -e 's/Q$//'
265 }
266
267 test_tick () {
268         if test -z "${test_tick+set}"
269         then
270                 test_tick=1112911993
271         else
272                 test_tick=$(($test_tick + 60))
273         fi
274         GIT_COMMITTER_DATE="$test_tick -0700"
275         GIT_AUTHOR_DATE="$test_tick -0700"
276         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
277 }
278
279 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
280 #
281 # This will commit a file with the given contents and the given commit
282 # message.  It will also add a tag with <message> as name.
283 #
284 # Both <file> and <contents> default to <message>.
285
286 test_commit () {
287         file=${2:-"$1.t"}
288         echo "${3-$1}" > "$file" &&
289         git add "$file" &&
290         test_tick &&
291         git commit -m "$1" &&
292         git tag "$1"
293 }
294
295 # Call test_merge with the arguments "<message> <commit>", where <commit>
296 # can be a tag pointing to the commit-to-merge.
297
298 test_merge () {
299         test_tick &&
300         git merge -m "$1" "$2" &&
301         git tag "$1"
302 }
303
304 # This function helps systems where core.filemode=false is set.
305 # Use it instead of plain 'chmod +x' to set or unset the executable bit
306 # of a file in the working directory and add it to the index.
307
308 test_chmod () {
309         chmod "$@" &&
310         git update-index --add "--chmod=$@"
311 }
312
313 # Use test_set_prereq to tell that a particular prerequisite is available.
314 # The prerequisite can later be checked for in two ways:
315 #
316 # - Explicitly using test_have_prereq.
317 #
318 # - Implicitly by specifying the prerequisite tag in the calls to
319 #   test_expect_{success,failure,code}.
320 #
321 # The single parameter is the prerequisite tag (a simple word, in all
322 # capital letters by convention).
323
324 test_set_prereq () {
325         satisfied="$satisfied$1 "
326 }
327 satisfied=" "
328
329 test_have_prereq () {
330         # prerequisites can be concatenated with ','
331         save_IFS=$IFS
332         IFS=,
333         set -- $*
334         IFS=$save_IFS
335
336         total_prereq=0
337         ok_prereq=0
338         missing_prereq=
339
340         for prerequisite
341         do
342                 total_prereq=$(($total_prereq + 1))
343                 case $satisfied in
344                 *" $prerequisite "*)
345                         ok_prereq=$(($ok_prereq + 1))
346                         ;;
347                 *)
348                         # Keep a list of missing prerequisites
349                         if test -z "$missing_prereq"
350                         then
351                                 missing_prereq=$prerequisite
352                         else
353                                 missing_prereq="$prerequisite,$missing_prereq"
354                         fi
355                 esac
356         done
357
358         test $total_prereq = $ok_prereq
359 }
360
361 # You are not expected to call test_ok_ and test_failure_ directly, use
362 # the text_expect_* functions instead.
363
364 test_ok_ () {
365         test_success=$(($test_success + 1))
366         say_color "" "ok $test_count - $@"
367 }
368
369 test_failure_ () {
370         test_failure=$(($test_failure + 1))
371         say_color error "not ok - $test_count $1"
372         shift
373         echo "$@" | sed -e 's/^/#       /'
374         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
375 }
376
377 test_known_broken_ok_ () {
378         test_fixed=$(($test_fixed+1))
379         say_color "" "ok $test_count - $@ # TODO known breakage"
380 }
381
382 test_known_broken_failure_ () {
383         test_broken=$(($test_broken+1))
384         say_color skip "not ok $test_count - $@ # TODO known breakage"
385 }
386
387 test_debug () {
388         test "$debug" = "" || eval "$1"
389 }
390
391 test_run_ () {
392         test_cleanup=:
393         eval >&3 2>&4 "$1"
394         eval_ret=$?
395         eval >&3 2>&4 "$test_cleanup"
396         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
397                 echo ""
398         fi
399         return 0
400 }
401
402 test_skip () {
403         test_count=$(($test_count+1))
404         to_skip=
405         for skp in $GIT_SKIP_TESTS
406         do
407                 case $this_test.$test_count in
408                 $skp)
409                         to_skip=t
410                         break
411                 esac
412         done
413         if test -z "$to_skip" && test -n "$prereq" &&
414            ! test_have_prereq "$prereq"
415         then
416                 to_skip=t
417         fi
418         case "$to_skip" in
419         t)
420                 of_prereq=
421                 if test "$missing_prereq" != "$prereq"
422                 then
423                         of_prereq=" of $prereq"
424                 fi
425
426                 say_color skip >&3 "skipping test: $@"
427                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
428                 : true
429                 ;;
430         *)
431                 false
432                 ;;
433         esac
434 }
435
436 test_expect_failure () {
437         test "$#" = 3 && { prereq=$1; shift; } || prereq=
438         test "$#" = 2 ||
439         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
440         if ! test_skip "$@"
441         then
442                 say >&3 "checking known breakage: $2"
443                 test_run_ "$2"
444                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
445                 then
446                         test_known_broken_ok_ "$1"
447                 else
448                         test_known_broken_failure_ "$1"
449                 fi
450         fi
451         echo >&3 ""
452 }
453
454 test_expect_success () {
455         test "$#" = 3 && { prereq=$1; shift; } || prereq=
456         test "$#" = 2 ||
457         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
458         if ! test_skip "$@"
459         then
460                 say >&3 "expecting success: $2"
461                 test_run_ "$2"
462                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
463                 then
464                         test_ok_ "$1"
465                 else
466                         test_failure_ "$@"
467                 fi
468         fi
469         echo >&3 ""
470 }
471
472 test_expect_code () {
473         test "$#" = 4 && { prereq=$1; shift; } || prereq=
474         test "$#" = 3 ||
475         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
476         if ! test_skip "$@"
477         then
478                 say >&3 "expecting exit code $1: $3"
479                 test_run_ "$3"
480                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
481                 then
482                         test_ok_ "$2"
483                 else
484                         test_failure_ "$@"
485                 fi
486         fi
487         echo >&3 ""
488 }
489
490 # test_external runs external test scripts that provide continuous
491 # test output about their progress, and succeeds/fails on
492 # zero/non-zero exit code.  It outputs the test output on stdout even
493 # in non-verbose mode, and announces the external script with "# run
494 # <n>: ..." before running it.  When providing relative paths, keep in
495 # mind that all scripts run in "trash directory".
496 # Usage: test_external description command arguments...
497 # Example: test_external 'Perl API' perl ../path/to/test.pl
498 test_external () {
499         test "$#" = 4 && { prereq=$1; shift; } || prereq=
500         test "$#" = 3 ||
501         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
502         descr="$1"
503         shift
504         if ! test_skip "$descr" "$@"
505         then
506                 # Announce the script to reduce confusion about the
507                 # test output that follows.
508                 say_color "" "# run $test_count: $descr ($*)"
509                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
510                 # to be able to use them in script
511                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
512                 # Run command; redirect its stderr to &4 as in
513                 # test_run_, but keep its stdout on our stdout even in
514                 # non-verbose mode.
515                 "$@" 2>&4
516                 if [ "$?" = 0 ]
517                 then
518                         if test $test_external_has_tap -eq 0; then
519                                 test_ok_ "$descr"
520                         else
521                                 say_color "" "# test_external test $descr was ok"
522                                 test_success=$(($test_success + 1))
523                         fi
524                 else
525                         if test $test_external_has_tap -eq 0; then
526                                 test_failure_ "$descr" "$@"
527                         else
528                                 say_color error "# test_external test $descr failed: $@"
529                                 test_failure=$(($test_failure + 1))
530                         fi
531                 fi
532         fi
533 }
534
535 # Like test_external, but in addition tests that the command generated
536 # no output on stderr.
537 test_external_without_stderr () {
538         # The temporary file has no (and must have no) security
539         # implications.
540         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
541         stderr="$tmp/git-external-stderr.$$.tmp"
542         test_external "$@" 4> "$stderr"
543         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
544         descr="no stderr: $1"
545         shift
546         say >&3 "# expecting no stderr from previous command"
547         if [ ! -s "$stderr" ]; then
548                 rm "$stderr"
549
550                 if test $test_external_has_tap -eq 0; then
551                         test_ok_ "$descr"
552                 else
553                         say_color "" "# test_external_without_stderr test $descr was ok"
554                         test_success=$(($test_success + 1))
555                 fi
556         else
557                 if [ "$verbose" = t ]; then
558                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
559                 else
560                         output=
561                 fi
562                 # rm first in case test_failure exits.
563                 rm "$stderr"
564                 if test $test_external_has_tap -eq 0; then
565                         test_failure_ "$descr" "$@" "$output"
566                 else
567                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
568                         test_failure=$(($test_failure + 1))
569                 fi
570         fi
571 }
572
573 # This is not among top-level (test_expect_success | test_expect_failure)
574 # but is a prefix that can be used in the test script, like:
575 #
576 #       test_expect_success 'complain and die' '
577 #           do something &&
578 #           do something else &&
579 #           test_must_fail git checkout ../outerspace
580 #       '
581 #
582 # Writing this as "! git checkout ../outerspace" is wrong, because
583 # the failure could be due to a segv.  We want a controlled failure.
584
585 test_must_fail () {
586         "$@"
587         test $? -gt 0 -a $? -le 129 -o $? -gt 192
588 }
589
590 # Similar to test_must_fail, but tolerates success, too.  This is
591 # meant to be used in contexts like:
592 #
593 #       test_expect_success 'some command works without configuration' '
594 #               test_might_fail git config --unset all.configuration &&
595 #               do something
596 #       '
597 #
598 # Writing "git config --unset all.configuration || :" would be wrong,
599 # because we want to notice if it fails due to segv.
600
601 test_might_fail () {
602         "$@"
603         test $? -ge 0 -a $? -le 129 -o $? -gt 192
604 }
605
606 # test_cmp is a helper function to compare actual and expected output.
607 # You can use it like:
608 #
609 #       test_expect_success 'foo works' '
610 #               echo expected >expected &&
611 #               foo >actual &&
612 #               test_cmp expected actual
613 #       '
614 #
615 # This could be written as either "cmp" or "diff -u", but:
616 # - cmp's output is not nearly as easy to read as diff -u
617 # - not all diff versions understand "-u"
618
619 test_cmp() {
620         $GIT_TEST_CMP "$@"
621 }
622
623 # This function can be used to schedule some commands to be run
624 # unconditionally at the end of the test to restore sanity:
625 #
626 #       test_expect_success 'test core.capslock' '
627 #               git config core.capslock true &&
628 #               test_when_finished "git config --unset core.capslock" &&
629 #               hello world
630 #       '
631 #
632 # That would be roughly equivalent to
633 #
634 #       test_expect_success 'test core.capslock' '
635 #               git config core.capslock true &&
636 #               hello world
637 #               git config --unset core.capslock
638 #       '
639 #
640 # except that the greeting and config --unset must both succeed for
641 # the test to pass.
642
643 test_when_finished () {
644         test_cleanup="{ $*
645                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
646 }
647
648 # Most tests can use the created repository, but some may need to create more.
649 # Usage: test_create_repo <directory>
650 test_create_repo () {
651         test "$#" = 1 ||
652         error "bug in the test script: not 1 parameter to test-create-repo"
653         owd=`pwd`
654         repo="$1"
655         mkdir -p "$repo"
656         cd "$repo" || error "Cannot setup test environment"
657         "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
658         error "cannot run git init -- have you built things yet?"
659         mv .git/hooks .git/hooks-disabled
660         cd "$owd"
661 }
662
663 test_done () {
664         GIT_EXIT_OK=t
665
666         if test -z "$HARNESS_ACTIVE"; then
667                 test_results_dir="$TEST_DIRECTORY/test-results"
668                 mkdir -p "$test_results_dir"
669                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
670
671                 echo "total $test_count" >> $test_results_path
672                 echo "success $test_success" >> $test_results_path
673                 echo "fixed $test_fixed" >> $test_results_path
674                 echo "broken $test_broken" >> $test_results_path
675                 echo "failed $test_failure" >> $test_results_path
676                 echo "" >> $test_results_path
677         fi
678
679         if test "$test_fixed" != 0
680         then
681                 say_color pass "# fixed $test_fixed known breakage(s)"
682         fi
683         if test "$test_broken" != 0
684         then
685                 say_color error "# still have $test_broken known breakage(s)"
686                 msg="remaining $(($test_count-$test_broken)) test(s)"
687         else
688                 msg="$test_count test(s)"
689         fi
690         case "$test_failure" in
691         0)
692                 # Maybe print SKIP message
693                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
694
695                 if test $test_external_has_tap -eq 0; then
696                         say_color pass "# passed all $msg"
697                         say "1..$test_count$skip_all"
698                 fi
699
700                 test -d "$remove_trash" &&
701                 cd "$(dirname "$remove_trash")" &&
702                 rm -rf "$(basename "$remove_trash")"
703
704                 exit 0 ;;
705
706         *)
707                 if test $test_external_has_tap -eq 0; then
708                         say_color error "# failed $test_failure among $msg"
709                         say "1..$test_count"
710                 fi
711
712                 exit 1 ;;
713
714         esac
715 }
716
717 # Test the binaries we have just built.  The tests are kept in
718 # t/ subdirectory and are run in 'trash directory' subdirectory.
719 if test -z "$TEST_DIRECTORY"
720 then
721         # We allow tests to override this, in case they want to run tests
722         # outside of t/, e.g. for running tests on the test library
723         # itself.
724         TEST_DIRECTORY=$(pwd)
725 fi
726 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
727
728 if test -n "$valgrind"
729 then
730         make_symlink () {
731                 test -h "$2" &&
732                 test "$1" = "$(readlink "$2")" || {
733                         # be super paranoid
734                         if mkdir "$2".lock
735                         then
736                                 rm -f "$2" &&
737                                 ln -s "$1" "$2" &&
738                                 rm -r "$2".lock
739                         else
740                                 while test -d "$2".lock
741                                 do
742                                         say "Waiting for lock on $2."
743                                         sleep 1
744                                 done
745                         fi
746                 }
747         }
748
749         make_valgrind_symlink () {
750                 # handle only executables
751                 test -x "$1" || return
752
753                 base=$(basename "$1")
754                 symlink_target=$GIT_BUILD_DIR/$base
755                 # do not override scripts
756                 if test -x "$symlink_target" &&
757                     test ! -d "$symlink_target" &&
758                     test "#!" != "$(head -c 2 < "$symlink_target")"
759                 then
760                         symlink_target=../valgrind.sh
761                 fi
762                 case "$base" in
763                 *.sh|*.perl)
764                         symlink_target=../unprocessed-script
765                 esac
766                 # create the link, or replace it if it is out of date
767                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
768         }
769
770         # override all git executables in TEST_DIRECTORY/..
771         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
772         mkdir -p "$GIT_VALGRIND"/bin
773         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
774         do
775                 make_valgrind_symlink $file
776         done
777         OLDIFS=$IFS
778         IFS=:
779         for path in $PATH
780         do
781                 ls "$path"/git-* 2> /dev/null |
782                 while read file
783                 do
784                         make_valgrind_symlink "$file"
785                 done
786         done
787         IFS=$OLDIFS
788         PATH=$GIT_VALGRIND/bin:$PATH
789         GIT_EXEC_PATH=$GIT_VALGRIND/bin
790         export GIT_VALGRIND
791 elif test -n "$GIT_TEST_INSTALLED" ; then
792         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
793         error "Cannot run git from $GIT_TEST_INSTALLED."
794         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
795         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
796 else # normal case, use ../bin-wrappers only unless $with_dashes:
797         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
798         if ! test -x "$git_bin_dir/git" ; then
799                 if test -z "$with_dashes" ; then
800                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
801                 fi
802                 with_dashes=t
803         fi
804         PATH="$git_bin_dir:$PATH"
805         GIT_EXEC_PATH=$GIT_BUILD_DIR
806         if test -n "$with_dashes" ; then
807                 PATH="$GIT_BUILD_DIR:$PATH"
808         fi
809 fi
810 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
811 unset GIT_CONFIG
812 GIT_CONFIG_NOSYSTEM=1
813 GIT_CONFIG_NOGLOBAL=1
814 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
815
816 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
817
818 if test -z "$GIT_TEST_CMP"
819 then
820         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
821         then
822                 GIT_TEST_CMP="$DIFF -c"
823         else
824                 GIT_TEST_CMP="$DIFF -u"
825         fi
826 fi
827
828 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
829 export GITPERLLIB
830 test -d "$GIT_BUILD_DIR"/templates/blt || {
831         error "You haven't built things yet, have you?"
832 }
833
834 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
835 then
836         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
837         export GITPYTHONLIB
838         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
839                 error "You haven't built git_remote_helpers yet, have you?"
840         }
841 fi
842
843 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
844         echo >&2 'You need to build test-chmtime:'
845         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
846         exit 1
847 fi
848
849 # Test repository
850 test="trash directory.$(basename "$0" .sh)"
851 test -n "$root" && test="$root/$test"
852 case "$test" in
853 /*) TRASH_DIRECTORY="$test" ;;
854  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
855 esac
856 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
857 rm -fr "$test" || {
858         GIT_EXIT_OK=t
859         echo >&5 "FATAL: Cannot prepare test area"
860         exit 1
861 }
862
863 test_create_repo "$test"
864 # Use -P to resolve symlinks in our working directory so that the cwd
865 # in subprocesses like git equals our $PWD (for pathname comparisons).
866 cd -P "$test" || exit 1
867
868 this_test=${0##*/}
869 this_test=${this_test%%-*}
870 for skp in $GIT_SKIP_TESTS
871 do
872         case "$this_test" in
873         $skp)
874                 say_color skip >&3 "skipping test $this_test altogether"
875                 skip_all="skip all tests in $this_test"
876                 test_done
877         esac
878 done
879
880 # Provide an implementation of the 'yes' utility
881 yes () {
882         if test $# = 0
883         then
884                 y=y
885         else
886                 y="$*"
887         fi
888
889         while echo "$y"
890         do
891                 :
892         done
893 }
894
895 # Fix some commands on Windows
896 case $(uname -s) in
897 *MINGW*)
898         # Windows has its own (incompatible) sort and find
899         sort () {
900                 /usr/bin/sort "$@"
901         }
902         find () {
903                 /usr/bin/find "$@"
904         }
905         sum () {
906                 md5sum "$@"
907         }
908         # git sees Windows-style pwd
909         pwd () {
910                 builtin pwd -W
911         }
912         # no POSIX permissions
913         # backslashes in pathspec are converted to '/'
914         # exec does not inherit the PID
915         ;;
916 *)
917         test_set_prereq POSIXPERM
918         test_set_prereq BSLASHPSPEC
919         test_set_prereq EXECKEEPSPID
920         ;;
921 esac
922
923 test -z "$NO_PERL" && test_set_prereq PERL
924 test -z "$NO_PYTHON" && test_set_prereq PYTHON
925
926 # test whether the filesystem supports symbolic links
927 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
928 rm -f y
929
930 # When the tests are run as root, permission tests will report that
931 # things are writable when they shouldn't be.
932 test -w / || test_set_prereq SANITY